<template>
  <div>
      <v-app-bar app color="#0b61a4" light clipped-left>
        <div class="d-flex align-right">
          <v-img
            alt="Vuetify Logo"
            class="shrink mr-2"
            contain
            src="../../../public/logo.png"
            transition="scale-transition"
            width="40"
          />
        </div>

        <v-toolbar-title class="white--text display-1">cocode</v-toolbar-title>

        <v-spacer></v-spacer>

        <v-card flat class="px-0 mx-0">
          <v-list dense nav dark color="#ff9200" class="py-0">
            <v-list-item v-bind:two-line="$vuetify.breakpoint.width > 500">
              <v-list-item-avatar
                :color="color"
                class="white--text"
                :class="{ 'mx-auto': $vuetify.breakpoint.width <= 500 }"
                @click="to_user"
              >
                <v-icon>{{ avatar }}</v-icon>
              </v-list-item-avatar>

              <v-list-item-content v-if="$vuetify.breakpoint.width > 500">
                <v-list-item-title>{{ name }}</v-list-item-title>
                <v-list-item-subtitle>你没有新消息了！</v-list-item-subtitle>
              </v-list-item-content>
            </v-list-item>
          </v-list>
        </v-card>
      </v-app-bar>
  </div>
</template>

<script>
export default {
  name: "appBar",
  data: () => ({
    showMenu: false,
    items: [{ title: "个人资料" }, { title: "设置" }, { title: "登出" }],
    temp: 1 // 强制刷新
    // avatar: "",
    //name: "",
    //color: "",
  }),
  computed: {
    name() {
      //通过sessionstorage获取vuex里islogin的状态
      this.temp;
      const sessionUserName = sessionStorage.getItem("userName");
      const sessionUserToken = sessionStorage.getItem("userToken");
      const sessionNickName = sessionStorage.getItem("nickName");
      if (sessionUserName && sessionUserToken) {
        this.$store.dispatch("setUserName", sessionUserName);
        this.$store.dispatch("setNickName", sessionNickName);
      } else {
        this.$store.dispatch("setUser", null);
      }

      return this.$store.getters.nickName;
      //return this.$store.getters.userName;
    },
    isLogin() {
      return this.$store.getters.isLogin;
    },
    avatar() {
      this.temp;
      const sessionAvatar = sessionStorage.getItem("userAvatar");
      this.$store.dispatch(
        "setUserAvatar",
        sessionAvatar ? sessionAvatar : null
      );
      return this.$store.getters.userAvatar;
    },
    color() {
      this.temp;
      const sessionColor = sessionStorage.getItem("userColor");
      this.$store.dispatch("setUserColor", sessionColor ? sessionColor : null);
      return this.$store.getters.userColor;
    }
  },
  methods: {
    interval(func, wait) {
      const interv = (function(w) {
        return () => {
          setTimeout(interv, w);
          func.call(null);
        };
      })(wait);

      setTimeout(interv, wait);
    },
    to_user() {
      this.$router.push("/user");
    }
  },
  mounted() {
    this.$evtbus.$on("User.UserInfoUpdated", () => {
      this.temp++;
    });

    const _roomId = new Date().getMilliseconds();
    this.interval(() => {
      this.$evtbus.$emit("User.TouchServer", {
        userName: this.$store.getters.userName,
        roomId: _roomId
      });
    }, 5000);

    // this.avatar = this.$store.getters.userAvatar;
    // this.nickName = this.$store.getters.nickName;
    // this.color = this.$store.getters.userColor;
  }
};
</script>
